/* ----------------------------------------------------------------------------
 * gxinterface -- Gtk+ Extended Interface
 * GxInterface Header
 *
 * ----------------------------------------------------------------------------
 * copyright © 2006, 2007, 2008, 2009, 2010 Jérôme BENHAÏM <benhaimjerome@gmail.com>
 *
 * ----------------------------------------------------------------------------
 *
 *   This file is part of GxInterface.
 *
 *	 GxInterface is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------
 *
 * Before attempting to install gtkmm 2.4, you might first need to install these other packages.

    * libsigc++ 2.0
    * GTK+ 2.4
    * cairomm

*These dependencies have their own dependencies, including the following applications and libraries:

    * pkg-config
    * glib
    * ATK
    * Pango
    * cairo
 */
#ifndef Gx_interface_H
    #define Gx_interface_H
	/* app */
    #include "common.h"
	#include "gemod.h"
 	// Liste des Class
    /* PROGRAMNAME_UI_DIR */
#define UI_FILE PROGRAMNAME_UI_DIR"interface.ui"

class Gx_interface {
	private:
		/* Application variables */	
		Glib::ustring iname;						/* interface name */
		Gemod* module_manager;						/* gestionnaire de module */
		Glib::ustring itype;

		Glib::ustring get_itype();
		//static gboolean version , interface_mode;	/* version et mode de l'interface */
		//static gchar **files;						/* interface files */
		/* option context */
		//GOptionContext *option_context;				/* interface files */
		//GOptionGroup *option_group;					/* interface files */
		//static GOptionEntry option_entries[];		/* interface files */
		/* Debugging arguments */	
		//static gboolean verbose;					/* interface files */
		//static GOptionEntry debug_option_entries[];	/* interface files */
		/* Error */
		GError *error;							/* interface files */
	protected:
	public:		
		Gx_interface(gint, gchar**);
		~Gx_interface();
		guint analyseparam(gint, gchar**);	
};	

#endif /* Gx_interface_H */
