/* ----------------------------------------------------------------------------
 * gxinterface -- Gtk+ Extended Interface
 * extended p_thread Header
 *
 * ----------------------------------------------------------------------------
 * copyright © 2006, 2007, 2008, 2009, 2010 Jérôme BENHAÏM <benhaimjerome@gmail.com>
 *
 * ----------------------------------------------------------------------------
 *
 *   This file is part of GxInterface.
 *
 *	 GxInterface is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------
 *
 * Classe Thread : 
 * classe générique qui comporte :
 * une méthode statique à faire éxécuter par un thread
 * une méthode abstraite à redéfinir qui retourne la condition de continuation de la boucle du thread
 * une méthode de lancement d'arret et de jonction : start arret join
 * 
 */
#ifndef GXTHREAD_H
	#define GXTHREAD_H
	#include <pthread.h>
 
class Thread {
private:
	int err;
	pthread_t thread;
	static void * T_Func(void *);
protected:
	/* function to define in your class is what the thread do */
	virtual bool Run() = 0;
	/* internal start */ 
	virtual int S_Thread(void* (* real_func)(void*));
	virtual int J_Thread(void* (* real_func)(void*));
	virtual int T_Thread(void* (* real_func)(void*));
	/* thread start */
	int S_Thread() { return S_Thread(&T_Func); };
	int T_Thread() { return T_Thread(&T_Func); };
	int J_Thread() { return J_Thread(&T_Func); };
public:
	/* constructor */
	Thread() { };
	/* internal constructor */
    Thread(void* (* real_func)(void*)) { S_Thread(real_func); };
	~Thread() { };	
};

void * Thread::T_Func(void * thread) {
	Thread * iThread = (Thread *)thread;
	while(iThread->Run()){};
};

int Thread::S_Thread(void* (* real_func)(void*)) { 
	//LOG_IN()

	if ( err = pthread_create( &thread, NULL, real_func, (void *)this) ){
		std::cout << t_fatal  << " " << err << " : " << __func__ << "ne peux CRÉER le thread" << std::endl;
		//LOG_OUT ();
		return err;
	}else{
		std::cout << "thread: start " << std::endl;
	};
	//LOG_OUT();
	return 0;
};
int Thread::T_Thread(void* (* real_func)(void*)) { 
	LOG_IN();
		pthread_exit(NULL);
	LOG_OUT();
	return 0;
};
int Thread::J_Thread(void* (* real_func)(void*)) { 
	LOG_IN();
		pthread_join(thread, NULL);
	LOG_OUT();
	return 0;
};



#endif /* GXTHREAD_H */
